local uabStatus_UnitClass = uabUnitStatus:NewModule("Unit Class")

uabStatus_UnitClass.defaultDB = {
    disabled = nil,
    druid = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    hunter = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    mage = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    paladin = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    priest = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    rogue = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    shaman = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    warlock = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    warrior = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
    },
    mana = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = nil,
            shaman = true,
            warlock = true,
            warrior = nil,
        },
    },
    caster = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = nil,
            mage = true,
            paladin = true,
            priest = true,
            rogue = nil,
            shaman = true,
            warlock = true,
            warrior = nil,
        },
    },
    healer = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = nil,
            mage = nil,
            paladin = true,
            priest = true,
            rogue = nil,
            shaman = true,
            warlock = nil,
            warrior = nil,
        },
    },
    ranged = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
    },
    melee = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = nil,
            mage = nil,
            paladin = true,
            priest = nil,
            rogue = true,
            shaman = true,
            warlock = nil,
            warrior = true,
        },
    },
    dps = {
        disabled = nil,
        priority = 50,
        color = { r = 0, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
    },
}

function uabStatus_UnitClass:OnInitialize()
    self.super.OnInitialize(self)

	self:RegisterUnitStatus("Class", "Class: Druid")
	self:RegisterUnitStatus("Class", "Class: Hunter")
	self:RegisterUnitStatus("Class", "Class: Mage")
	self:RegisterUnitStatus("Class", "Class: Paladin")
	self:RegisterUnitStatus("Class", "Class: Priest")
	self:RegisterUnitStatus("Class", "Class: Rogue")
	self:RegisterUnitStatus("Class", "Class: Shaman")
	self:RegisterUnitStatus("Class", "Class: Warlock")
	self:RegisterUnitStatus("Class", "Class: Warrior")
	
    self:RegisterUnitStatus("ClassGroup", "ClassGroup: Mana")
	self:RegisterUnitStatus("ClassGroup", "ClassGroup: Caster")
	self:RegisterUnitStatus("ClassGroup", "ClassGroup: Healer")
	self:RegisterUnitStatus("ClassGroup", "ClassGroup: Ranged")
	self:RegisterUnitStatus("ClassGroup", "ClassGroup: Melee")
	self:RegisterUnitStatus("ClassGroup", "ClassGroup: DPS")
end

function uabStatus_UnitClass:OnEnable()
end

function uabStatus_UnitClass:OnDisable()
end

function uabStatus_UnitClass:IsStatusGained(name, unit, action)
    local class = self:GetUnitClass(unit)
    local isclass

    if class then
        local status = string.find(name, "ClassGroup: (.+)")
        if not status then
            status = string.find(name, "Class: (.*)")
    
            status = string.lower(status)
            if status == class then
                isclass = true
            end
        else
            status = string.lower(status)
            if self.db.profile[status] then
                if self.db.profile[status].classfilter[class] then
                    isclass = true
                end
            end
        end
    end
    
    return isclass
end

function uabStatus_UnitClass:OptionsForUnitStatus(name)
	if name == "Class: Druid" then
		return self.db.profile.druid
    elseif name == "Class: Hunter" then
		return self.db.profile.hunter
    elseif name == "Class: Mage" then
		return self.db.profile.mage
    elseif name == "Class: Paladin" then
		return self.db.profile.paladin
    elseif name == "Class: Priest" then
		return self.db.profile.priest
    elseif name == "Class: Rogue" then
		return self.db.profile.rogue
    elseif name == "Class: Shaman" then
		return self.db.profile.shaman
    elseif name == "Class: Warlock" then
		return self.db.profile.warlock
    elseif name == "Class: Warrior" then
		return self.db.profile.warrior
    elseif name == "ClassGroup: Mana" then
		return self.db.profile.mana
    elseif name == "ClassGroup: Caster" then
		return self.db.profile.caster
    elseif name == "ClassGroup: Healer" then
		return self.db.profile.healer
    elseif name == "ClassGroup: Ranged" then
		return self.db.profile.ranged
    elseif name == "ClassGroup: Melee" then
		return self.db.profile.melee
    elseif name == "ClassGroup: DPS" then
		return self.db.profile.dps
	end
end

function uabStatus_UnitClass:CreateUnitStatusOptions()
    local args = {}

    args = {
        type = 'group',
        name = "Class Check",
        desc = "Configure the options for Class Check unit status values",
        args = {
            enabled = {
                type = 'toggle',
                name = "Enabled",
                desc = "When checked, enable the use of the Class Check unit status values",
                order = 1,
                get = function()
                    return not self.db.profile.disabled
                end,
                set = function(v)
                    self.db.profile.disabled = not v
                end,
            },

            spacing3 = {
                name = " ",
                type = 'header',
                order = 5,
            },
        },
    }

    args.args.druid = self:CreateUnitStatusOption(self.db.profile.druid, "Class: Druid", "Class: Druid", false)
    args.args.druid.order = 10

    args.args.hunter = self:CreateUnitStatusOption(self.db.profile.hunter, "Class: Hunter", "Class: Hunter", false)
    args.args.hunter.order = 20

    args.args.mage = self:CreateUnitStatusOption(self.db.profile.mage, "Class: Mage", "Class: Mage", false)
    args.args.mage.order = 30

    args.args.paladin = self:CreateUnitStatusOption(self.db.profile.paladin, "Class: Paladin", "Class: Paladin", false)
    args.args.paladin.order = 40

    args.args.priest = self:CreateUnitStatusOption(self.db.profile.priest, "Class: Priest", "Class: Priest", false)
    args.args.priest.order = 50

    args.args.rogue = self:CreateUnitStatusOption(self.db.profile.rogue, "Class: Rogue", "Class: Rogue", false)
    args.args.rogue.order = 60

    args.args.shaman = self:CreateUnitStatusOption(self.db.profile.shaman, "Class: Shaman", "Class: Shaman", false)
    args.args.shaman.order = 70

    args.args.warlock = self:CreateUnitStatusOption(self.db.profile.warlock, "Class: Warlock", "Class: Warlock", false)
    args.args.warlock.order = 80

    args.args.warrior = self:CreateUnitStatusOption(self.db.profile.warrior, "Class: Warrior", "Class: Warrior", false)
    args.args.warrior.order = 90

    args.args.mana = self:CreateUnitStatusOption(self.db.profile.mana, "ClassGroup: Mana", "ClassGroup: Mana", true)
    args.args.mana.order = 100

    args.args.caster = self:CreateUnitStatusOption(self.db.profile.caster, "ClassGroup: Caster", "ClassGroup: Caster", true)
    args.args.caster.order = 110

    args.args.healer = self:CreateUnitStatusOption(self.db.profile.healer, "ClassGroup: Healer", "ClassGroup: Healer", true)
    args.args.healer.order = 120

    args.args.ranged = self:CreateUnitStatusOption(self.db.profile.ranged, "ClassGroup: Ranged", "ClassGroup: Ranged", true)
    args.args.ranged.order = 130

    args.args.melee = self:CreateUnitStatusOption(self.db.profile.melee, "ClassGroup: Melee", "ClassGroup: Melee", true)
    args.args.melee.order = 140

    args.args.dps = self:CreateUnitStatusOption(self.db.profile.dps, "ClassGroup: DPS", "ClassGroup: DPS", true)
    args.args.dps.order = 150

    return args
end

